<?php

/*******************************************************************************/
//                          InstantCMS v1.10                                    //
//                      http://www.instantcms.ru/                              //
//                     API to http://nextgame.ru                               //
//                     written by Marat Fatikhov                               //
//                      (nickname Марат on a site)                             //
//                       E-mail: f-marat@mail.ru                               //
//                                                                             //
//                      LICENSED BY GNU/GPL v2                                 //
//                                                                             //
/********************************************************************************/



if(!defined('VALID_CMS')) { die('ACCESS DENIED'); }


define('API_SECRET_KEY','******************************************');
define('SITE_ID','***');

// функция для формирования ответа ошибки
function ErrorReply($code,$msg){
    $reply = '<?xml version="1.0" encoding="UTF-8"?><error><code>'.$code.'</code><msg>'.$msg.'</msg></error>';
    return $reply;
}


//функция для проверки сигнатуры
function isSignatureValid (){
    $param = $_GET;//получаем параметры запроса
    $sig = $param['sig'];//берем подпись
    $line = '';
    unset($param['sig']);//удаляем из параметров подпись
    ksort($param);//сортируем параметры по алфавиту
    foreach ($param as $name => $value) {
        $line .= $name . '=' . $value;//добавляем строку пары ключ=значение
    }
    $line .= API_SECRET_KEY;//добавляем ключ сервер-сервер
   if ($sig == md5($line)) {//проверяем подписи
       return true;//подпись совпала
   }else {
       return false;
   };
}

//функция добавляет подпись к урл
function addServerSignature($url) {
    $param = '';
    mb_parse_str(parse_url($url, PHP_URL_QUERY), $param);//получаем параметры из ссылки в массив
    $line = '';
    ksort($param);
    foreach ($param as $name => $value) {
        $line .= $name . '=' . $value;//добавляем строку пары ключ=значение
    }
    $line .= API_SECRET_KEY;//добавляем ключ сервер-сервер
    $url .= '&sig=' . md5($line);//добавляем в ссылку подпись
    return $url;
}

//формирует код получения игры в виде названия
function getLinkGame($user_id, $app_id ){
  $url = 'http://api2.nextgame.ru/iframe/js/link/?app_id='.$app_id.'&site_id='.SITE_ID.'&user_id='.$user_id ;
  $url =  addServerSignature($url);
  $code =  '<script type=\'text/javascript\' src=\''.$url.'\'></script>';
  return $code;
}

//формирует код получения игры в виде логотипа
function getLogoLinkGame($user_id, $app_id ){
    $url = 'http://api2.nextgame.ru/iframe/js/link/?app_id='.$app_id.'&site_id='.SITE_ID.'&user_id='.$user_id.'&linktype=1' ;
  $url =  addServerSignature($url);
  $code =  '<script type=\'text/javascript\' src=\''.$url.'\'></script>';
  return $code;
}

//формирует код размещения в iframe
function getIframeGame($user_id, $app_id ){
    $url = 'http://api2.nextgame.ru/iframe/js/?app_id='.$app_id.'&site_id='.SITE_ID.'&user_id='.$user_id ;
  $url =  addServerSignature($url);
  $code =  '<script type=\'text/javascript\' src=\''.$url.'\'></script>';
  return $code;
}

?>
